#  Copyright (c) 2019 Markus Ressel
#  .
#  Permission is hereby granted, free of charge, to any person obtaining a copy
#  of this software and associated documentation files (the "Software"), to deal
#  in the Software without restriction, including without limitation the rights
#  to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
#  copies of the Software, and to permit persons to whom the Software is
#  furnished to do so, subject to the following conditions:
#  .
#  The above copyright notice and this permission notice shall be included in all
#  copies or substantial portions of the Software.
#  .
#  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
#  IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
#  FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
#  AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
#  LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
#  OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
#  SOFTWARE.
from container_app_conf.entry.string import StringConfigEntry
from tests import EntryTestBase, TestConfigBase


class SecretTest(EntryTestBase):

    def test_secret_entry(self):
        config_entry = StringConfigEntry(key_path=["string"], required=False)
        self.assertFalse(config_entry.secret)
        config_entry = StringConfigEntry(key_path=["string"], required=False, secret=False)
        self.assertFalse(config_entry.secret)
        config_entry = StringConfigEntry(key_path=["string"], required=False, secret=True)
        self.assertTrue(config_entry.secret)

    def test_secret_current_config(self):
        config = TestConfigBase()
        from container_app_conf.formatter.yaml import YamlFormatter
        output = config.print(YamlFormatter())
        # output = config.print()

        for secret_entry in list(filter(lambda x: x.secret and x.value is not None, config._config_entries.values())):
            self.assertNotIn(str(secret_entry.value), output)
